﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public GameName As String
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private UpdateBalanceDialog As CustomLayoutDialog
	Private BalanceInputText As EditText
	Private PlayerBalancesLV As CustomListView
	Private BalanceItemLabel As Label
End Sub

Private Sub InsertGameData
	Main.DB.ReadGame(GameName)
	Dim PlayersList As List = Main.DB.ListGamePlayers
	For i = 0 To PlayersList.Size - 1
		Dim Bal As String = Main.DB.GetBalance(PlayersList.Get(i), "")
		PlayerBalancesLV.Add(CreateBalanceItemLabel(Bal, PlayersList.Get(i)), "")
	Next
End Sub

Private Sub CreateBalanceItemLabel (Text As String, Tag As String) As Panel
	Dim P As Panel
	P.Initialize("")
	P.LoadLayout("BalanceItem")
	BalanceItemLabel.Text = Text
	BalanceItemLabel.Tag = Tag
	Return P
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("BalanceViewActivity")
	Activity.Title = GameName
	Activity.AddMenuItem("Rename Game", "RenameGame")
	Activity.AddMenuItem("Delete Game", "DeleteGame")
	Activity.AddMenuItem3("?", "Help", Null, True)
	InsertGameData
End Sub

Public Sub Help_Click
	Dim MS As String = $"To update a player's balance tap the player. Tap and hold to view the player's balance history"$
	Msgbox(MS, "How To Use")
End Sub

Public Sub BalanceItemLabel_Click
	Dim B As Label = Sender
	Dim SF As Object = UpdateBalanceDialog.ShowAsync("Update Balance", "Update", "Cancel", "", Null, True)
	UpdateBalanceDialog.SetSize(100%x, 100dip)
	Wait For Dialog_Ready (DialogPanel As Panel)
	DialogPanel.LoadLayout("UpdateBalanceDialog")
	BalanceInputText.InputType = BalanceInputText.INPUT_TYPE_NUMBERS
	Wait For (SF) Dialog_Result (Result As Int)
	BalanceInputText.Enabled = False
	If Result = DialogResponse.POSITIVE Then
		If BalanceInputText.Text = "" Then
			Msgbox("You must input a balance inorder to update it", "Null Balance")
		Else
			Main.DB.UpdateBalance(B.Tag, BalanceInputText.Text)
		End If
	End If	
End Sub

Public Sub BalanceItemLabel_LongClick
	ToastMessageShow("Ability to view balance history is coming in the near future!", False)
End Sub

Public Sub BalanceInputText_TextChanged (Old As String, New As String)
	Dim Valid As Boolean = BalanceInputText.Text.Length > 0
	UpdateBalanceDialog.GetButton(DialogResponse.POSITIVE).Enabled = Valid
End Sub