﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private PlayersLV As ListView
	Private NameDialog As CustomLayoutDialog
	Private NameText As EditText
	Private OptionLabel As Label
End Sub

Public Sub InsertPlayerList
	Dim PL As List = Main.DB.ListAllPlayers
	PL.Sort(True)
	If PL.IsInitialized Then
		PlayersLV.Clear
		For i = 0 To PL.Size - 1
			PlayersLV.AddSingleLine(PL.Get(i))
		Next		
	End If
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("ViewPlayersActivity")
	Activity.AddMenuItem("Add Player", "AddPlayer")
	Activity.AddMenuItem("Add Dummy Players", "AddDummyPlayers")
	InsertPlayerList
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub AddPlayer_Click
	Dim SF As Object = NameDialog.ShowAsync("Add Player", "Add", "Cancel", "", Null, True)
	Wait For (SF) Dialog_Ready (DialogPanel As Panel)
	NameDialog.SetSize(100%x, 100dip)
	DialogPanel.LoadLayout("PlayerOptionsDialog")
	OptionLabel.Text = "Name:"
	Wait For (SF) Dialog_Result (Result As Int)
	NameText.Enabled = False
	If Result = DialogResponse.POSITIVE Then
		Main.DB.AddPlayer(NameText.Text)
		InsertPlayerList
	End If
End Sub

Public Sub AddDummyPlayers
	For i = 1 To 5
		Main.DB.AddPlayer($"Player #${i}"$)
	Next
	InsertPlayerList
End Sub

Public Sub PlayersLV_ItemClick (Position As Int, Value As Object)
	Dim Resp As Int = InputList(Array As String("Rename", "Delete"), "Available Actions", -1)
	If Resp = 0 Then
		Dim SF As Object = NameDialog.ShowAsync($"Renaming ${Value}"$, "Rename", "Cancel", "", Null, True)
		NameDialog.SetSize(100%x, 100dip)
		Wait For (SF) Dialog_Ready (DialogPanel As Panel)
		DialogPanel.LoadLayout("PlayerOptionsDialog")
		OptionLabel.Text = $"Rename To:"$
		Wait For (SF) Dialog_Result (Result As Int)
		NameText.Enabled = False
		If Result = DialogResponse.POSITIVE Then
			Main.DB.RenamePlayer(Value, NameText.Text)
			InsertPlayerList
		End If
	Else If Resp = 1 Then
		Msgbox2Async($"Are you sure you want to delete "${Value}" from the database?"$, "Deletion Confirmation", "Delete", "Keep", "", Null, True)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.POSITIVE Then
			Main.DB.DeletePlayer(Value)
			ToastMessageShow($"Successfully removed "${Value}" from the database!"$, False)
			InsertPlayerList
		End If
	End If
End Sub

Sub NameText_TextChanged (Old As String, New As String)
	If NameText.Text.Length = 0 Then NameDialog.GetButton(DialogResponse.POSITIVE).Enabled = False
	NameDialog.GetButton(DialogResponse.POSITIVE).Enabled = True
End Sub